# IShRasterLayer Struct Reference
[MCImage]

Inheritance diagram for IShRasterLayer:

List of all members.

## Classes
class | TCMYKATileReader
| Undocumented. More...
class | TCMYKTileReader
| Undocumented. More...
class | TRGBATileReader
| Undocumented. More...
class | TRGBTileReader
| Undocumented. More...
## Public Types
enum | ELayerMode { kNormalMode = 'norm', kAdditionMode = 'add ', kDifferenceMode = 'diff', kMultiplyMode = 'mult', kScreenMode = 'scrn', kHardLightMode = 'hLit', kUnknownMode = '****' }
## Public Member Functions
virtual MCCOMErr MCCOMAPI | GetBounds (TMCRect &out_bounds)=0
virtual MCCOMErr MCCOMAPI | SetBounds (const TMCRect &in_bounds)=0
virtual MCCOMErr MCCOMAPI | GetExtendedBounds (TMCRect &out_bounds)=0
virtual MCCOMErr MCCOMAPI | ExtendBounds (int32 top, int32 left, int32 right, int32 bottom)=0
virtual uint32 MCCOMAPI | GetMemorySizeForColorChannel (uint32 width, uint32 height)=0
virtual uint16 MCCOMAPI | GetColorBitDepth ()=0
virtual MCCOMErr MCCOMAPI | Clone (IShRasterLayer **clone)=0
virtual MCCOMErr MCCOMAPI | CopyFrom (IShRasterLayer *copy)=0
virtual boolean MCCOMAPI | IsEqual (IShRasterLayer *other)=0
virtual MCCOMErr MCCOMAPI | GetLayerTileIteratorRGB (IShRasterLayerTileIterator **out_iter, const TMCRect &in_target)=0
virtual MCCOMErr MCCOMAPI | GetLayerTileIteratorRGBA (IShRasterLayerTileIterator **out_iter, const TMCRect &in_target)=0
virtual MCCOMErr MCCOMAPI | GetLayerTileIteratorCMYK (IShRasterLayerTileIterator **out_iter, const TMCRect &in_target)=0
virtual MCCOMErr MCCOMAPI | GetLayerTileIteratorCMYKA (IShRasterLayerTileIterator **out_iter, const TMCRect &in_target)=0
virtual MCCOMErr MCCOMAPI | GetTileSize (TMCRect &out_size)=0
virtual uint32 MCCOMAPI | GetTileIndexFromPoint (const TMCPoint &point, TMCPoint *out_offset=NULL) const =0
virtual MCCOMErr MCCOMAPI | GetRectFromTileIndex (uint32 index, TMCRect &outTileBounds, const TMCRect *inTileBounds=NULL) const =0
virtual MCCOMErr MCCOMAPI | GetGlobalCoordinates (uint32 tileIndex, const TMCRect &rectInTile, TMCRect &rectInGlobal) const =0
virtual MCCOMErr MCCOMAPI | GlobalToLocal (const TMCRect &global, TMCRect &local) const =0
virtual MCCOMErr MCCOMAPI | GlobalToLocal (const TMCPoint &global, TMCPoint &local) const =0
virtual MCCOMErr MCCOMAPI | GetRGBData (const TMCRect &in_source, TChannelDataBucket dest[3], void *in_buffer[3], TDataAccessFlags flags)=0
virtual MCCOMErr MCCOMAPI | GetRGBAData (const TMCRect &in_source, TChannelDataBucket dest[4], void *in_buffer[4], TDataAccessFlags flags)=0
virtual MCCOMErr MCCOMAPI | GetCMYKData (const TMCRect &in_source, TChannelDataBucket dest[4], void *in_buffer[4], TDataAccessFlags flags)=0
virtual MCCOMErr MCCOMAPI | GetCMYKAData (const TMCRect &in_source, TChannelDataBucket dest[5], void *in_buffer[5], TDataAccessFlags flags)=0
virtual MCCOMErr MCCOMAPI | UnGetRGBData (TChannelDataBucket dest[3], boolean dirty)=0
virtual MCCOMErr MCCOMAPI | UnGetRGBAData (TChannelDataBucket dest[4], boolean dirty)=0
virtual MCCOMErr MCCOMAPI | UnGetCMYKData (TChannelDataBucket dest[4], boolean dirty)=0
virtual MCCOMErr MCCOMAPI | UnGetCMYKAData (TChannelDataBucket dest[5], boolean dirty)=0
virtual MCCOMErr MCCOMAPI | PutRGBData (TChannelDataBucket source_array[3], const TMCRect &dest, TDataAccessFlags flags)=0
virtual MCCOMErr MCCOMAPI | PutRGBAData (TChannelDataBucket source_array[4], const TMCRect &dest, TDataAccessFlags flags)=0
virtual MCCOMErr MCCOMAPI | PutCMYKData (TChannelDataBucket source_array[4], const TMCRect &dest, TDataAccessFlags flags)=0
virtual MCCOMErr MCCOMAPI | PutCMYKAData (TChannelDataBucket source_array[5], const TMCRect &dest, TDataAccessFlags flags)=0
virtual MCCOMErr MCCOMAPI | GetRGBTile (const TMCRect &in_source, const TChannelDataBucket *bucket[3], ETileAccess flags, TMCRect *out_localSource=NULL)=0
virtual MCCOMErr MCCOMAPI | GetRGBATile (const TMCRect &in_source, const TChannelDataBucket *bucket[4], ETileAccess flags, TMCRect *out_localSource=NULL)=0
virtual MCCOMErr MCCOMAPI | GetCMYKTile (const TMCRect &in_source, const TChannelDataBucket *bucket[4], ETileAccess flags, TMCRect *out_localSource=NULL)=0
virtual MCCOMErr MCCOMAPI | GetCMYKATile (const TMCRect &in_source, const TChannelDataBucket *bucket[5], ETileAccess flags, TMCRect *out_localSource=NULL)=0
virtual MCCOMErr MCCOMAPI | GetRGBTile (uint32 in_tileIndex, const TChannelDataBucket *bucket[3], ETileAccess flags, const TMCRect &inTile)=0
virtual MCCOMErr MCCOMAPI | GetRGBATile (uint32 in_tileIndex, const TChannelDataBucket *bucket[4], ETileAccess flags, const TMCRect &inTile)=0
virtual MCCOMErr MCCOMAPI | GetCMYKTile (uint32 in_tileIndex, const TChannelDataBucket *bucket[4], ETileAccess flags, const TMCRect &inTile)=0
virtual MCCOMErr MCCOMAPI | GetCMYKATile (uint32 in_tileIndex, const TChannelDataBucket *bucket[5], ETileAccess flags, const TMCRect &inTile)=0
virtual MCCOMErr MCCOMAPI | UnGetRGBTile (const TChannelDataBucket *const bucket[3], boolean dirty)=0
virtual MCCOMErr MCCOMAPI | UnGetRGBATile (const TChannelDataBucket *const bucket[4], boolean dirty)=0
virtual MCCOMErr MCCOMAPI | UnGetCMYKTile (const TChannelDataBucket *const bucket[4], boolean dirty)=0
virtual MCCOMErr MCCOMAPI | UnGetCMYKATile (const TChannelDataBucket *const bucket[5], boolean dirty)=0
virtual MCCOMErr MCCOMAPI | PutRGBTile (const TMCRect &dest, const TChannelDataBucket *const source_array[3], ETileAccess flags)=0
virtual MCCOMErr MCCOMAPI | PutRGBATile (const TMCRect &dest, const TChannelDataBucket *const source_array[4], ETileAccess flags)=0
virtual MCCOMErr MCCOMAPI | PutCMYKTile (const TMCRect &dest, const TChannelDataBucket *const source_array[4], ETileAccess flags)=0
virtual MCCOMErr MCCOMAPI | PutCMYKATile (const TMCRect &dest, const TChannelDataBucket *const source_array[5], ETileAccess flags)=0
virtual MCCOMErr MCCOMAPI | PutRGBTile (uint32 tileIndex, const TChannelDataBucket *const source_array[3], ETileAccess flags, const TMCRect &inTile)=0
virtual MCCOMErr MCCOMAPI | PutRGBATile (uint32 tileIndex, const TChannelDataBucket *const source_array[4], ETileAccess flags, const TMCRect &inTile)=0
virtual MCCOMErr MCCOMAPI | PutCMYKTile (uint32 tileIndex, const TChannelDataBucket *const source_array[4], ETileAccess flags, const TMCRect &inTile)=0
virtual MCCOMErr MCCOMAPI | PutCMYKATile (uint32 tileIndex, const TChannelDataBucket *const source_array[5], ETileAccess flags, const TMCRect &inTile)=0
virtual MCCOMErr MCCOMAPI | GetRgbSpan (int32 x, int32 y, int32 w, void *buf, uint8 bitdepth)=0
virtual MCCOMErr MCCOMAPI | PutRgbSpan (int32 x, int32 y, int32 w, void *buf, uint8 bitdepth)=0
virtual MCCOMErr MCCOMAPI | GetAlphaTileUniformValue (const TMCRect &in_rect, boolean &is_uniform, uint32 &value)=0
virtual MCCOMErr MCCOMAPI | GetPixelRGB (const TMCPoint inPoint, TArrayRGB &pixel)=0
virtual MCCOMErr MCCOMAPI | GetPixelRGBA (const TMCPoint inPoint, TArrayRGBA &pixel)=0
virtual MCCOMErr MCCOMAPI | GetPixelRGBList (const TMCPoint *inPointList, TArrayRGB *pixelList, int32 howMany)=0
virtual MCCOMErr MCCOMAPI | GetPixelRGBAList (const TMCPoint *inPointList, TArrayRGBA *pixelList, int32 howMany)=0
virtual MCCOMErr MCCOMAPI | GetMedian (TMCPoint inPoint, uint16 radius, TArrayRGB &pixel)=0
virtual MCCOMErr MCCOMAPI | GetInterpolatedPixelRGB (const TVector2 &inVector, TArrayRGB &pixel)=0
virtual MCCOMErr MCCOMAPI | GetInterpolatedPixelRGBA (const TVector2 &inVector, TArrayRGBA &pixel)=0
virtual MCCOMErr MCCOMAPI | GetInterpolatedPixelRGBList (const TVector2 *inVectorList, TArrayRGB *pixelList, int32 howMany)=0
virtual MCCOMErr MCCOMAPI | GetInterpolatedPixelRGBAList (const TVector2 *inVectorList, TArrayRGBA *pixelList, int32 howMany)=0
virtual MCCOMErr MCCOMAPI | GetContentChangeChannel (IChangeChannel **changeChannel)=0
virtual MCCOMErr MCCOMAPI | GetPropertyChangeChannel (IChangeChannel **changeChannel)=0
virtual MCCOMErr MCCOMAPI | PrepareOperation (void)=0
virtual MCCOMErr MCCOMAPI | EndOperation (void)=0
virtual MCCOMErr MCCOMAPI | Invalidate (const TMCRect &invalRect, uint32 channelSetMask)=0
virtual MCCOMErr MCCOMAPI | GetName (TMCString &name) const =0
virtual MCCOMErr MCCOMAPI | SetName (const TMCString &name)=0
virtual boolean MCCOMAPI | GetVisibility () const =0
virtual MCCOMErr MCCOMAPI | SetVisibility (boolean visibility)=0
virtual boolean MCCOMAPI | GetLock () const =0
virtual MCCOMErr MCCOMAPI | SetLock (boolean lock)=0
virtual boolean MCCOMAPI | GetPreserveTransparency () const =0
virtual MCCOMErr MCCOMAPI | SetPreserveTransparency (boolean preserve)=0
virtual real MCCOMAPI | GetOpacity () const =0
virtual MCCOMErr MCCOMAPI | SetOpacity (real opacity)=0
virtual real MCCOMAPI | GetDPI () const =0
virtual MCCOMErr MCCOMAPI | SetDPI (real dpi)=0
virtual ELayerMode MCCOMAPI | GetLayerMode () const =0
virtual void MCCOMAPI | SetLayerMode (ELayerMode mode)=0
virtual uint16 MCCOMAPI | GetChannelCount ()=0
virtual MCCOMErr MCCOMAPI | GetIShChannel (uint16 index, IShChannel **out_channel)=0
virtual MCCOMErr MCCOMAPI | CreateChannel (IShChannel **channel, const TChannelID &id, uint32 bitDepth)=0
virtual void MCCOMAPI | AddChannel (IShChannel *channel)=0
virtual void MCCOMAPI | RemoveChannel (IShChannel *channel)=0
virtual MCCOMErr MCCOMAPI | GetRasterLayerChannelIterator (IShRasterLayerChannelIterator **outIter)=0
virtual uint16 MCCOMAPI | GetChannelCountByID (const TChannelID &in_id)=0
virtual MCCOMErr MCCOMAPI | GetChannelByID (const TChannelID &id, IShChannel **out_channel)=0
virtual MCCOMErr MCCOMAPI | MatchChannelID2Index (const TChannelID in_ids[], uint16 indexes[], uint16 channel_count)=0
virtual MCCOMErr MCCOMAPI | GetData (const TMCRect &source, TChannelDataBucket dest_array[], void *buffer[], uint16 indexes[], uint16 numChannels, TDataAccessFlags flags, IYeildCallBackFunc *callBack)=0
virtual MCCOMErr MCCOMAPI | UnGetData (TChannelDataBucket dest_array[], uint16 indexes[], uint16 numChannels, boolean dirty)=0
virtual MCCOMErr MCCOMAPI | PutData (TChannelDataBucket source_array[], const TMCRect &dest, uint16 indexes[], uint16 numChannels, TDataAccessFlags flags)=0
virtual MCCOMErr MCCOMAPI | GetRasterLayerTileIterator (IShRasterLayerTileIterator **iter, uint16 indexes[], uint16 numChannels, const TMCRect &target)=0
virtual MCCOMErr MCCOMAPI | GetTile (const TMCRect &source, const TChannelDataBucket *bucket[], uint16 indexes[], uint16 numChannels, ETileAccess flags, TMCRect *out_localSource=NULL)=0
virtual MCCOMErr MCCOMAPI | GetTile (uint32 in_tileIndex, const TChannelDataBucket *bucket[], uint16 indexes[], uint16 numChannels, ETileAccess flags, const TMCRect &inTile)=0
virtual MCCOMErr MCCOMAPI | UnGetTile (const TChannelDataBucket *bucket[], uint16 indexes[], uint16 numChannels, boolean dirty)=0
virtual MCCOMErr MCCOMAPI | PutTile (const TMCRect &dest, const TChannelDataBucket *const source_array[], uint16 indexes[], uint16 numChannels, ETileAccess flags)=0
virtual MCCOMErr MCCOMAPI | PutTile (uint32 tileIndex, const TChannelDataBucket *const source_array[], uint16 indexes[], uint16 numChannels, ETileAccess flags, const TMCRect &inTile)=0
virtual MCCOMErr MCCOMAPI | GetTileRect (int32 x, int32 y, TMCRect &out_neiborhood)=0
virtual boolean MCCOMAPI | IsRGB () const =0
virtual boolean MCCOMAPI | IsCMYK () const =0
virtual MCCOMErr MCCOMAPI | CreateRGBChannelsFromCMYK ()=0
virtual MCCOMErr MCCOMAPI | CreateCMYKChannelsFromRGB ()=0
virtual MCCOMErr MCCOMAPI | GetRGBChannelSetMask (uint32 &channelSetMask)=0
virtual MCCOMErr MCCOMAPI | GetCMYKChannelSetMask (uint32 &channelSetMask)=0
virtual MCCOMErr MCCOMAPI | GetAlphaChannelSetMask (uint32 &channelSetMask)=0
virtual MCCOMErr MCCOMAPI | GetRGBIndices (uint16 indices[3])=0
virtual MCCOMErr MCCOMAPI | GetRGBAIndices (uint16 indices[4])=0
virtual MCCOMErr MCCOMAPI | GetCMYKIndices (uint16 indices[4])=0
virtual MCCOMErr MCCOMAPI | GetCMYKAIndices (uint16 indices[5])=0
virtual ELayerColorType MCCOMAPI | GetColorType () const =0
virtual void | SetColorType (ELayerColorType cType)=0
virtual MCCOMErr MCCOMAPI | GenerateChunkyChannel (IShChannel **channel, const TMCImageTileParameters *params=NULL)=0
virtual void MCCOMAPI | SetUsePreMultipliedAlpha (boolean usePreMultipliedAlpha)=0
virtual boolean MCCOMAPI | UsePreMultipliedAlpha ()=0
virtual void MCCOMAPI | BlendLayer (IShRasterLayer *layer, ELayerMode mode, real32 opacity)=0

## Detailed Description

IShRasterLayer is an interface to manipulate the different channels of an image. An image is divided in rectangles called tiles than can be swapped on the hard drive to keep the memory usage low. So when accessing them, you must lock and unlock the tiles that interest you by calling GetTile() and then UnGetTile() when you're done.

For rectangles that do not match a tile, you need to allocate one or more buffers, call GetData() and then UnGetData() when you are done. Note that the image data might NOT be copied into your buffers, so you must use the TChannelDataBucket to access the pixels.

When you work in read-write mode and UnGet data or tiles, you need to pass true for the "dirty" argument to cmomit your changes.

## Member Enumeration Documentation

enum IShRasterLayer::ELayerMode

Enumerator:

  kNormalMode |
  kAdditionMode |
  kDifferenceMode |
  kMultiplyMode |
  kScreenMode |
  kHardLightMode |
  kUnknownMode |

## Member Function Documentation

virtual void MCCOMAPI IShRasterLayer::AddChannel | ( | IShChannel * | channel | ) | `[pure virtual]`

virtual void MCCOMAPI IShRasterLayer::BlendLayer | ( | IShRasterLayer * | layer,
|  | ELayerMode | mode,
|  | real32 | opacity |
| ) |  |  | `[pure virtual]`

Blend a layer on top of this one.

Parameters:

  | layer | The layer to blend on top
  | mode | Blend mode.
  | opacity | Opacity.

virtual MCCOMErr MCCOMAPI IShRasterLayer::Clone | ( | IShRasterLayer ** | clone | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::CopyFrom | ( | IShRasterLayer * | copy | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::CreateChannel | ( | IShChannel ** | channel,
|  | const TChannelID & | id,
|  | uint32 | bitDepth |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::CreateCMYKChannelsFromRGB | ( |  | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::CreateRGBChannelsFromCMYK | ( |  | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::EndOperation | ( | void |  | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::ExtendBounds | ( | int32 | top,
|  | int32 | left,
|  | int32 | right,
|  | int32 | bottom |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GenerateChunkyChannel | ( | IShChannel ** | channel,
|  | const TMCImageTileParameters * | params = `NULL` |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetAlphaChannelSetMask | ( | uint32 & | channelSetMask | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetAlphaTileUniformValue | ( | const TMCRect & | in_rect,
|  | boolean & | is_uniform,
|  | uint32 & | value |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetBounds | ( | TMCRect & | out_bounds | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetChannelByID | ( | const TChannelID & | id,
|  | IShChannel ** | out_channel |
| ) |  |  | `[pure virtual]`

virtual uint16 MCCOMAPI IShRasterLayer::GetChannelCount | ( |  | ) | `[pure virtual]`

virtual uint16 MCCOMAPI IShRasterLayer::GetChannelCountByID | ( | const TChannelID & | in_id | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetCMYKAData | ( | const TMCRect & | in_source,
|  | TChannelDataBucket | dest[5],
|  | void * | in_buffer[5],
|  | TDataAccessFlags | flags |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetCMYKAIndices | ( | uint16 | indices[5] | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetCMYKATile | ( | uint32 | in_tileIndex,
|  | const TChannelDataBucket * | bucket[5],
|  | ETileAccess | flags,
|  | const TMCRect & | inTile |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetCMYKATile | ( | const TMCRect & | in_source,
|  | const TChannelDataBucket * | bucket[5],
|  | ETileAccess | flags,
|  | TMCRect * | out_localSource = `NULL` |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetCMYKChannelSetMask | ( | uint32 & | channelSetMask | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetCMYKData | ( | const TMCRect & | in_source,
|  | TChannelDataBucket | dest[4],
|  | void * | in_buffer[4],
|  | TDataAccessFlags | flags |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetCMYKIndices | ( | uint16 | indices[4] | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetCMYKTile | ( | uint32 | in_tileIndex,
|  | const TChannelDataBucket * | bucket[4],
|  | ETileAccess | flags,
|  | const TMCRect & | inTile |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetCMYKTile | ( | const TMCRect & | in_source,
|  | const TChannelDataBucket * | bucket[4],
|  | ETileAccess | flags,
|  | TMCRect * | out_localSource = `NULL` |
| ) |  |  | `[pure virtual]`

virtual uint16 MCCOMAPI IShRasterLayer::GetColorBitDepth | ( |  | ) | `[pure virtual]`

virtual ELayerColorType MCCOMAPI IShRasterLayer::GetColorType | ( |  | ) | const`[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetContentChangeChannel | ( | IChangeChannel ** | changeChannel | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetData | ( | const TMCRect & | source,
|  | TChannelDataBucket | dest_array[],
|  | void * | buffer[],
|  | uint16 | indexes[],
|  | uint16 | numChannels,
|  | TDataAccessFlags | flags,
|  | IYeildCallBackFunc * | callBack |
| ) |  |  | `[pure virtual]`

virtual real MCCOMAPI IShRasterLayer::GetDPI | ( |  | ) | const`[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetExtendedBounds | ( | TMCRect & | out_bounds | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetGlobalCoordinates | ( | uint32 | tileIndex,
|  | const TMCRect & | rectInTile,
|  | TMCRect & | rectInGlobal |
| ) |  |  | const`[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetInterpolatedPixelRGB | ( | const TVector2 & | inVector,
|  | TArrayRGB & | pixel |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetInterpolatedPixelRGBA | ( | const TVector2 & | inVector,
|  | TArrayRGBA & | pixel |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetInterpolatedPixelRGBAList | ( | const TVector2 * | inVectorList,
|  | TArrayRGBA * | pixelList,
|  | int32 | howMany |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetInterpolatedPixelRGBList | ( | const TVector2 * | inVectorList,
|  | TArrayRGB * | pixelList,
|  | int32 | howMany |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetIShChannel | ( | uint16 | index,
|  | IShChannel ** | out_channel |
| ) |  |  | `[pure virtual]`

virtual ELayerMode MCCOMAPI IShRasterLayer::GetLayerMode | ( |  | ) | const`[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetLayerTileIteratorCMYK | ( | IShRasterLayerTileIterator ** | out_iter,
|  | const TMCRect & | in_target |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetLayerTileIteratorCMYKA | ( | IShRasterLayerTileIterator ** | out_iter,
|  | const TMCRect & | in_target |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetLayerTileIteratorRGB | ( | IShRasterLayerTileIterator ** | out_iter,
|  | const TMCRect & | in_target |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetLayerTileIteratorRGBA | ( | IShRasterLayerTileIterator ** | out_iter,
|  | const TMCRect & | in_target |
| ) |  |  | `[pure virtual]`

virtual boolean MCCOMAPI IShRasterLayer::GetLock | ( |  | ) | const`[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetMedian | ( | TMCPoint | inPoint,
|  | uint16 | radius,
|  | TArrayRGB & | pixel |
| ) |  |  | `[pure virtual]`

virtual uint32 MCCOMAPI IShRasterLayer::GetMemorySizeForColorChannel | ( | uint32 | width,
|  | uint32 | height |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetName | ( | TMCString & | name | ) | const`[pure virtual]`

virtual real MCCOMAPI IShRasterLayer::GetOpacity | ( |  | ) | const`[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetPixelRGB | ( | const TMCPoint | inPoint,
|  | TArrayRGB & | pixel |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetPixelRGBA | ( | const TMCPoint | inPoint,
|  | TArrayRGBA & | pixel |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetPixelRGBAList | ( | const TMCPoint * | inPointList,
|  | TArrayRGBA * | pixelList,
|  | int32 | howMany |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetPixelRGBList | ( | const TMCPoint * | inPointList,
|  | TArrayRGB * | pixelList,
|  | int32 | howMany |
| ) |  |  | `[pure virtual]`

virtual boolean MCCOMAPI IShRasterLayer::GetPreserveTransparency | ( |  | ) | const`[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetPropertyChangeChannel | ( | IChangeChannel ** | changeChannel | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetRasterLayerChannelIterator | ( | IShRasterLayerChannelIterator ** | outIter | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetRasterLayerTileIterator | ( | IShRasterLayerTileIterator ** | iter,
|  | uint16 | indexes[],
|  | uint16 | numChannels,
|  | const TMCRect & | target |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetRectFromTileIndex | ( | uint32 | index,
|  | TMCRect & | outTileBounds,
|  | const TMCRect * | inTileBounds = `NULL` |
| ) |  |  | const`[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetRGBAData | ( | const TMCRect & | in_source,
|  | TChannelDataBucket | dest[4],
|  | void * | in_buffer[4],
|  | TDataAccessFlags | flags |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetRGBAIndices | ( | uint16 | indices[4] | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetRGBATile | ( | uint32 | in_tileIndex,
|  | const TChannelDataBucket * | bucket[4],
|  | ETileAccess | flags,
|  | const TMCRect & | inTile |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetRGBATile | ( | const TMCRect & | in_source,
|  | const TChannelDataBucket * | bucket[4],
|  | ETileAccess | flags,
|  | TMCRect * | out_localSource = `NULL` |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetRGBChannelSetMask | ( | uint32 & | channelSetMask | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetRGBData | ( | const TMCRect & | in_source,
|  | TChannelDataBucket | dest[3],
|  | void * | in_buffer[3],
|  | TDataAccessFlags | flags |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetRGBIndices | ( | uint16 | indices[3] | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetRgbSpan | ( | int32 | x,
|  | int32 | y,
|  | int32 | w,
|  | void * | buf,
|  | uint8 | bitdepth |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetRGBTile | ( | uint32 | in_tileIndex,
|  | const TChannelDataBucket * | bucket[3],
|  | ETileAccess | flags,
|  | const TMCRect & | inTile |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetRGBTile | ( | const TMCRect & | in_source,
|  | const TChannelDataBucket * | bucket[3],
|  | ETileAccess | flags,
|  | TMCRect * | out_localSource = `NULL` |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetTile | ( | uint32 | in_tileIndex,
|  | const TChannelDataBucket * | bucket[],
|  | uint16 | indexes[],
|  | uint16 | numChannels,
|  | ETileAccess | flags,
|  | const TMCRect & | inTile |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetTile | ( | const TMCRect & | source,
|  | const TChannelDataBucket * | bucket[],
|  | uint16 | indexes[],
|  | uint16 | numChannels,
|  | ETileAccess | flags,
|  | TMCRect * | out_localSource = `NULL` |
| ) |  |  | `[pure virtual]`

virtual uint32 MCCOMAPI IShRasterLayer::GetTileIndexFromPoint | ( | const TMCPoint & | point,
|  | TMCPoint * | out_offset = `NULL` |
| ) |  |  | const`[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetTileRect | ( | int32 | x,
|  | int32 | y,
|  | TMCRect & | out_neiborhood |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GetTileSize | ( | TMCRect & | out_size | ) | `[pure virtual]`

virtual boolean MCCOMAPI IShRasterLayer::GetVisibility | ( |  | ) | const`[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GlobalToLocal | ( | const TMCPoint & | global,
|  | TMCPoint & | local |
| ) |  |  | const`[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::GlobalToLocal | ( | const TMCRect & | global,
|  | TMCRect & | local |
| ) |  |  | const`[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::Invalidate | ( | const TMCRect & | invalRect,
|  | uint32 | channelSetMask |
| ) |  |  | `[pure virtual]`

virtual boolean MCCOMAPI IShRasterLayer::IsCMYK | ( |  | ) | const`[pure virtual]`

virtual boolean MCCOMAPI IShRasterLayer::IsEqual | ( | IShRasterLayer * | other | ) | `[pure virtual]`

virtual boolean MCCOMAPI IShRasterLayer::IsRGB | ( |  | ) | const`[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::MatchChannelID2Index | ( | const TChannelID | in_ids[],
|  | uint16 | indexes[],
|  | uint16 | channel_count |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::PrepareOperation | ( | void |  | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::PutCMYKAData | ( | TChannelDataBucket | source_array[5],
|  | const TMCRect & | dest,
|  | TDataAccessFlags | flags |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::PutCMYKATile | ( | uint32 | tileIndex,
|  | const TChannelDataBucket *const | source_array[5],
|  | ETileAccess | flags,
|  | const TMCRect & | inTile |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::PutCMYKATile | ( | const TMCRect & | dest,
|  | const TChannelDataBucket *const | source_array[5],
|  | ETileAccess | flags |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::PutCMYKData | ( | TChannelDataBucket | source_array[4],
|  | const TMCRect & | dest,
|  | TDataAccessFlags | flags |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::PutCMYKTile | ( | uint32 | tileIndex,
|  | const TChannelDataBucket *const | source_array[4],
|  | ETileAccess | flags,
|  | const TMCRect & | inTile |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::PutCMYKTile | ( | const TMCRect & | dest,
|  | const TChannelDataBucket *const | source_array[4],
|  | ETileAccess | flags |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::PutData | ( | TChannelDataBucket | source_array[],
|  | const TMCRect & | dest,
|  | uint16 | indexes[],
|  | uint16 | numChannels,
|  | TDataAccessFlags | flags |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::PutRGBAData | ( | TChannelDataBucket | source_array[4],
|  | const TMCRect & | dest,
|  | TDataAccessFlags | flags |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::PutRGBATile | ( | uint32 | tileIndex,
|  | const TChannelDataBucket *const | source_array[4],
|  | ETileAccess | flags,
|  | const TMCRect & | inTile |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::PutRGBATile | ( | const TMCRect & | dest,
|  | const TChannelDataBucket *const | source_array[4],
|  | ETileAccess | flags |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::PutRGBData | ( | TChannelDataBucket | source_array[3],
|  | const TMCRect & | dest,
|  | TDataAccessFlags | flags |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::PutRgbSpan | ( | int32 | x,
|  | int32 | y,
|  | int32 | w,
|  | void * | buf,
|  | uint8 | bitdepth |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::PutRGBTile | ( | uint32 | tileIndex,
|  | const TChannelDataBucket *const | source_array[3],
|  | ETileAccess | flags,
|  | const TMCRect & | inTile |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::PutRGBTile | ( | const TMCRect & | dest,
|  | const TChannelDataBucket *const | source_array[3],
|  | ETileAccess | flags |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::PutTile | ( | uint32 | tileIndex,
|  | const TChannelDataBucket *const | source_array[],
|  | uint16 | indexes[],
|  | uint16 | numChannels,
|  | ETileAccess | flags,
|  | const TMCRect & | inTile |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::PutTile | ( | const TMCRect & | dest,
|  | const TChannelDataBucket *const | source_array[],
|  | uint16 | indexes[],
|  | uint16 | numChannels,
|  | ETileAccess | flags |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShRasterLayer::RemoveChannel | ( | IShChannel * | channel | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::SetBounds | ( | const TMCRect & | in_bounds | ) | `[pure virtual]`

virtual void IShRasterLayer::SetColorType | ( | ELayerColorType | cType | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::SetDPI | ( | real | dpi | ) | `[pure virtual]`

virtual void MCCOMAPI IShRasterLayer::SetLayerMode | ( | ELayerMode | mode | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::SetLock | ( | boolean | lock | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::SetName | ( | const TMCString & | name | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::SetOpacity | ( | real | opacity | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::SetPreserveTransparency | ( | boolean | preserve | ) | `[pure virtual]`

virtual void MCCOMAPI IShRasterLayer::SetUsePreMultipliedAlpha | ( | boolean | usePreMultipliedAlpha | ) | `[pure virtual]`

Sets whether this layer contains color channel with premultiplied alpha or not

Parameters:

  | usePreMultipliedAlpha | true if the alpha is already multiplied in the color (this is the default)

virtual MCCOMErr MCCOMAPI IShRasterLayer::SetVisibility | ( | boolean | visibility | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::UnGetCMYKAData | ( | TChannelDataBucket | dest[5],
|  | boolean | dirty |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::UnGetCMYKATile | ( | const TChannelDataBucket *const | bucket[5],
|  | boolean | dirty |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::UnGetCMYKData | ( | TChannelDataBucket | dest[4],
|  | boolean | dirty |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::UnGetCMYKTile | ( | const TChannelDataBucket *const | bucket[4],
|  | boolean | dirty |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::UnGetData | ( | TChannelDataBucket | dest_array[],
|  | uint16 | indexes[],
|  | uint16 | numChannels,
|  | boolean | dirty |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::UnGetRGBAData | ( | TChannelDataBucket | dest[4],
|  | boolean | dirty |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::UnGetRGBATile | ( | const TChannelDataBucket *const | bucket[4],
|  | boolean | dirty |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::UnGetRGBData | ( | TChannelDataBucket | dest[3],
|  | boolean | dirty |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::UnGetRGBTile | ( | const TChannelDataBucket *const | bucket[3],
|  | boolean | dirty |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShRasterLayer::UnGetTile | ( | const TChannelDataBucket * | bucket[],
|  | uint16 | indexes[],
|  | uint16 | numChannels,
|  | boolean | dirty |
| ) |  |  | `[pure virtual]`

virtual boolean MCCOMAPI IShRasterLayer::UsePreMultipliedAlpha | ( |  | ) | `[pure virtual]`

Returns true if the layer contains color channels with premultiplied alpha, false otherwhise.

The documentation for this struct was generated from the following file:

- IShRasterLayer.h